freeslot("SKINCOLOR_S3SUPER1","SKINCOLOR_S3SUPER2","SKINCOLOR_S3SUPER3",
"SKINCOLOR_S3HYPER0","SKINCOLOR_S3HYPER1","SKINCOLOR_S3HYPER2","SKINCOLOR_S3HYPER3",
"SKINCOLOR_S3HYPER4","SKINCOLOR_S3HYPER5","SKINCOLOR_S3HYPER6","SKINCOLOR_DARKTDH")

skincolors[SKINCOLOR_S3SUPER1] = {
    name = "S3SUPER1",
    ramp = {80,80,81,81,81,82,82,82,82,82,82,82,83,83,83,83},
    invcolor = SKINCOLOR_BLUE,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3SUPER2] = {
    name = "S3SUPER2",
    ramp = {80,81,82,82,82,83,83,83,64,64,65,65,65,66,67,68},
    invcolor = SKINCOLOR_BLUE,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3SUPER3] = {
    name = "S3SUPER3",
    ramp = {81,82,83,72,72,73,73,74,74,75,76,76,76,77,78,79},
    invcolor = SKINCOLOR_BLUE,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER0] = {
    name = "S3HYPER0",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER1] = {
    name = "S3HYPER1",
    ramp = {0,0,0,0,84,84,84,84,65,65,65,65,66,66,66,66},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER2] = {
    name = "S3HYPER2",
    ramp = {0,0,0,0,209,209,209,209,210,210,210,210,211,211,211,211},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER3] = {
    name = "S3HYPER3",
    ramp = {0,0,0,0,200,200,200,200,201,201,201,201,202,202,202,202},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER4] = {
    name = "S3HYPER4",
    ramp = {0,0,0,0,145,145,145,145,170,170,170,170,171,171,171,171},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER5] = {
    name = "S3HYPER5",
    ramp = {0,0,0,0,89,89,89,89,113,113,113,113,114,114,114,114},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_S3HYPER6] = {
    name = "S3HYPER6",
    ramp = {0,0,0,0,72,72,72,72,74,74,74,74,75,75,75,75},
    invcolor = SKINCOLOR_BLACK,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

skincolors[SKINCOLOR_DARKTDH] = {
	name = "how'd you end up here",
    ramp = {253,253,253,253,253,253,253,254,31,31,31,31,31,31,31,31},
    invcolor = SKINCOLOR_WHITE,
    invshade = 7,
    chatcolor = V_INVERTMAP,
    accessible = false
}

addHook("PlayerThink", function(player)
    if (player.mo and player.valid) and (player.mo.skin == "s3sonic")
        local S1,S2,S3 = SKINCOLOR_S3SUPER1 , SKINCOLOR_S3SUPER2 , SKINCOLOR_S3SUPER3
        local H0,H1,H2,H3,H4,H5,H6 = SKINCOLOR_S3HYPER0,SKINCOLOR_S3HYPER1,SKINCOLOR_S3HYPER2,SKINCOLOR_S3HYPER3,SKINCOLOR_S3HYPER4,SKINCOLOR_S3HYPER5,SKINCOLOR_S3HYPER6
        local s3SuperColors = {S1,S2,S3}
        local s3HyperColors = {H0,H1,H0,H2,H0,H3,H0,H4,H0,H5,H0,H6}
        
        player.s3supercolor = $ or 1
        player.s3hypercolor = $ or 1
        player.s3colortime = $ or 0
        
        if (player.s3supercolor > 3)
            player.s3supercolor = 1
        end
        
        if (player.s3hypercolor > 12)
            player.s3hypercolor = 1
        end
        
        if (player.powers[pw_super] and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS5)) or ((player.powers[pw_carry] == CR_NIGHTSMODE) and not (player.mo.state >= S_PLAY_NIGHTS_TRANS1 and player.mo.state <= S_PLAY_NIGHTS_TRANS5))
            player.s3colortime = $ + 1
            if (player.s3hyper == 1) and not (player.powers[pw_carry] == CR_NIGHTSMODE)
                player.mo.color = s3HyperColors[player.s3hypercolor]
                if (player.s3colortime > 2)
                    player.s3hypercolor = $ + 1
                    player.s3colortime = 0
                end
            else
                player.mo.color = s3SuperColors[player.s3supercolor]
                if (player.s3colortime > 4)
                    player.s3supercolor = $ + 1
                    player.s3colortime = 0
                end
            end
        else
            player.s3supercolor = 1
            player.s3hypercolor = 1
            player.s3colortime = 0
        end
        
    end
end)